﻿Public Class Form1

    ' Speichert alle zu zeichnenden Objekte
    Private ObjectList As New List(Of GraphicObject)
    Private WithEvents _Rubberband As Rubberband

    Public Sub New()

        ' Dieser Aufruf ist für den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fügen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        _Rubberband = New Rubberband(PictureBox1)
        _Rubberband.Style = Rubberband.Styles.Line
        _Rubberband.ClientRectOnly = True
        _Rubberband.RestrictionRect = Rectangle.Empty
        _Rubberband.Mode = Rubberband.Modes.MouseDown
    End Sub

    Private Sub rbLine_Click(ByVal sender As Object, _
                             ByVal e As System.EventArgs) Handles rbLine.Click
        _Rubberband.Style = Rubberband.Styles.Line
        btnSelCol.Enabled = False
    End Sub

    Private Sub rbFrame_Click(ByVal sender As Object, _
                              ByVal e As System.EventArgs) Handles rbFrame.Click
        _Rubberband.Style = Rubberband.Styles.Frame
        btnSelCol.Enabled = False
    End Sub

    Private Sub rbRect_Click(ByVal sender As Object, _
                             ByVal e As System.EventArgs) Handles rbRect.Click
        _Rubberband.Style = Rubberband.Styles.Rectangle
        btnSelCol.Enabled = True
    End Sub

    Private Sub rbNone_Click(ByVal sender As Object, _
                             ByVal e As System.EventArgs) Handles rbNone.Click
        _Rubberband.RestrictionRect = Rectangle.Empty
        _Rubberband.ClientRectOnly = False
    End Sub

    Private Sub rbForm_Click(ByVal sender As Object, _
                             ByVal e As System.EventArgs) Handles rbForm.Click
        _Rubberband.RestrictionRect = Me.ClientRectangle
        _Rubberband.ClientRectOnly = False
    End Sub

    Private Sub rbPicture_Click(ByVal sender As Object, _
                                ByVal e As System.EventArgs) _
                            Handles rbPicture.Click
        _Rubberband.RestrictionRect = Rectangle.Empty
        _Rubberband.ClientRectOnly = True
    End Sub

    Private Sub btnSelCol_Click(ByVal sender As System.Object, _
                                ByVal e As System.EventArgs) _
                            Handles btnSelCol.Click
        cdBackground.Color = picColor.BackColor
        cdBackground.AllowFullOpen = True
        cdBackground.FullOpen = True
        If cdBackground.ShowDialog() = Windows.Forms.DialogResult.OK Then
            picColor.BackColor = cdBackground.Color
            _Rubberband.BackColor = cdBackground.Color
        End If
    End Sub

    Private Sub btnStart_Click(ByVal sender As System.Object, _
                               ByVal e As System.EventArgs) _
                           Handles btnStart.Click
        Dim btns As MouseButtons = Windows.Forms.MouseButtons.None
        Dim cbtns As MouseButtons = Windows.Forms.MouseButtons.None
        If chkLeft.Checked Then
            btns = btns Or Windows.Forms.MouseButtons.Left
        End If
        If chkMiddle.Checked Then
            btns = btns Or Windows.Forms.MouseButtons.Middle
        End If
        If chkRight.Checked Then
            btns = btns Or Windows.Forms.MouseButtons.Right
        End If
        If chkCLeft.Checked Then
            cbtns = cbtns Or Windows.Forms.MouseButtons.Left
        End If
        If chkCMiddle.Checked Then
            cbtns = cbtns Or Windows.Forms.MouseButtons.Middle
        End If
        If chkCRight.Checked Then
            cbtns = cbtns Or Windows.Forms.MouseButtons.Right
        End If
        If btns = Windows.Forms.MouseButtons.None Then Exit Sub
        _Rubberband.Start(btns, cbtns)
    End Sub

    Private Sub _Rubberband_Aborted(ByVal sender As Object, _
                                    ByVal e As System.EventArgs) _
                                Handles _Rubberband.Aborted
        MessageBox.Show("Rubberband wurde abgebrochen", "Abbruchmeldung")
    End Sub

    Private Sub _Rubberband_Finished(ByVal sender As Object, _
                                     ByVal e As RubberBandEventArgs) _
                                 Handles _Rubberband.Finished
        ' GraphicObject erstellen
        Dim go As New GraphicObject
        If _Rubberband.Style <> Rubberband.Styles.Line Then
            go.Shape = GraphicObject.Shapes.Rectangle
            go.Rectangle = e.Area
        Else
            go.Shape = GraphicObject.Shapes.Line
            go.Point1 = e.StartedAt
            go.Point2 = e.EndedAt
            go.Rectangle = e.Area
        End If
        ' der liste hinzufügen
        ObjectList.Add(go)
        ' Zeichnung ausgeben
        PictureBox1.Invalidate(e.Area)
    End Sub

    Private Sub PictureBox1_Paint(ByVal sender As Object, _
            ByVal e As System.Windows.Forms.PaintEventArgs) _
            Handles PictureBox1.Paint
        For Each go As GraphicObject In ObjectList
            go.Draw(e.Graphics)
        Next
    End Sub

    Private Sub rbMouseDown_Click(ByVal sender As Object, _
                                  ByVal e As System.EventArgs) _
                              Handles rbMouseDown.Click
        _Rubberband.Mode = Rubberband.Modes.MouseDown
    End Sub

    Private Sub rbMouseclick_Click(ByVal sender As Object, _
                                   ByVal e As System.EventArgs) _
                               Handles rbMouseclick.Click
        _Rubberband.Mode = Rubberband.Modes.Click
    End Sub
End Class
